@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashAPartSuper
set /A failure_count=0

    if "%device_has_system%" NEQ "1" (
        goto :skipFlashSystem
    )

    REM This is a discriminant for system image.
    set /A A=0
    if exist system.img set /A A+=1
    if exist system.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different formats System image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_super!" EQU "1" (
            goto :skipFlashSystem
        )
        color fc
        echo.
        echo Fatal Error: System image does not exist. This is obviously wrong, please check the firmware location path^^!
        exit /b 1
    )
    REM if %A% EQU 1
    if exist system.img_sparsechunk* (
        echo.
        echo ------ Flashing sparse System image ------
        REM Initialize the variable to 0.
        set flash_failed=0
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 system.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse System image: %%a
            %fastboot% -s %serial_number% flash system%slotsuffix% %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo ------------------------------
                echo Fatal Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            exit /b 1
        )
    ) else (
        if exist system.img (
            echo.
            echo ------ Flashing full System image ------
            !fastboot! -s !serial_number! flash system!slotsuffix! system.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash system failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )

    if "%slotsuffix%" EQU "_b" (
        goto :skipFlashSystemBImage
    )

    REM This is a discriminant for system_b image.
    set /A A=0
    if exist system_other.img set /A A+=1
    if exist system_b.img_sparsechunk* set /A A+=1
    if exist system_other.img_sparsechunk.* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Full and sparse System_B image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_ab_slot!" EQU "1" (
            echo.
            echo Note: Full or sparse System_B image does not exist, but your device contain this partition, skip flashing...
            goto :skipFlashSystemBImage
        )
    )
    if %A% EQU 1 (
        if "!device_ab_slot!" EQU "0" (
            color fc
            echo.
            echo Fatal Error! You device not support slot A/B partition, why put System_B image into flash tool?
            exit /b 1
        )
    )

    REM if %A% EQU 1
    if exist system_b.img_sparsechunk.* (
        echo.
        echo ------ Flashing sparse System_B image ------
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 system_b.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse System_B image: %%a
            %fastboot% -s %serial_number% flash system_b %%a
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
    )
    if exist system_other.img_sparsechunk.* (
        echo.
        echo ------ Flashing sparse System_B image ------
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 system_other.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse System_B image: %%a
            %fastboot% -s %serial_number% flash system_b %%a
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
    )
    if exist system_other.img (
        echo.
        echo ------ Flashing full System_B image ------
        %fastboot% -s %serial_number% flash system_b system_other.img
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo Error: fastboot flash system_b failed^^!
            echo ------------------------------
        )
    )
    :skipFlashSystemBImage
    :skipFlashSystem

    if "%device_has_product%" NEQ "1" (
        goto :skipFlashProduct
    )

    REM This is a discriminant for product image.
    set /A A=0
    if exist product.img set /A A+=1
    if exist product.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Full and sparse Product image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_super!" EQU "1" (
            goto :skipFlashProduct
        )
        echo.
        echo Note: Full or sparse Product image does not exist, but your device contain this partition, skip flashing...
        goto :skipFlashProduct
    )
    REM if %A% EQU 1
    if exist product.img_sparsechunk* (
        echo.
        echo ------ Flashing sparse Product image ------
        REM Initialize the variable to 0.
        set flash_failed=0
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 product.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse Product image: %%a
            %fastboot% -s %serial_number% flash product%slotsuffix% %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo ------------------------------
                echo Fatal Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            exit /b 1
        )
    ) else (
        if exist product.img (
            echo.
            echo ------ Flashing full Product image ------
            !fastboot! -s !serial_number! flash product!slotsuffix! product.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash product failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )
    :skipFlashProduct

    if "%device_has_vendor%" NEQ "1" (
        goto :skipFlashVendor
    )

    REM This is a discriminant for vendor image.
    set /A A=0
    if exist vendor.img set /A A+=1
    if exist vendor.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Full and sparse Vendor image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_super!" EQU "1" (
            goto :skipFlashVendor
        )
        echo.
        echo Note: Full or sparse Vendor image does not exist, but your device contain this partition, skip flashing...
        goto :skipFlashVendor
    )

    REM if %A% EQU 1
    if exist vendor.img_sparsechunk* (
        echo.
        echo ------ Flashing sparse Vendor image ------
        set flash_failed=0
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 vendor.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse Vendor image: %%a
            %fastboot% -s %serial_number% flash vendor%slotsuffix% %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo ------------------------------
                echo Fatal Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            exit /b 1
        )
    ) else (
        if exist vendor.img (
            echo.
            echo ------ Flashing full Vendor image ------
            !fastboot! -s !serial_number! flash vendor!slotsuffix! vendor.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash vendor failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )
    :skipFlashVendor

    if "%device_has_oem%" NEQ "1" (
        goto :skipFlashOem
    )

    REM This is a discriminant for oem image.
    set /A A=0
    if exist oem.img set /A A+=1
    if exist oem.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Full and sparse Oem image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        echo.
        echo Note: Full or sparse Oem image does not exist, but your device contain this partition, skip flashing...
        goto :skipFlashOem
    )

    REM if %A% EQU 1
    if exist oem.img_sparsechunk* (
        echo.
        echo ------ Flashing sparse Oem image ------
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 oem.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse Oem image: %%a
            %fastboot% -s %serial_number% flash oem%slotsuffix% %%a
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Fatal Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
    ) else (
        if exist oem.img (
            echo.
            echo ------ Flashing full Oem image ------
            !fastboot! -s !serial_number! flash oem!slotsuffix! oem.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash oem failed^^!
                echo ------------------------------
            )
        )
    )

    if "%slotsuffix%" EQU "_b" (
        goto :skipFlashOemBImage
    )

    REM This is a discriminant for oem_b image.
    set /A A=0
    if exist oem_other.img set /A A+=1
    if exist oem_b.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Full and sparse Oem_B image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_ab_slot!" EQU "1" (
            echo.
            echo Note: Full or sparse Oem_B image does not exist, but your device contain this partition, skip flashing...
        )
    )
    if %A% EQU 1 (
        if "!device_ab_slot!" EQU "0" (
            color fc
            echo.
            echo Fatal Error! You device not support slot A/B partition, why put System_B image into flash tool?
            exit /b 1
        )
    )

    REM if %A% EQU 1
    if exist oem_b.img_sparsechunk* (
        echo.
        echo ------ Flashing sparse Oem_B image ------
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 oem_b.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse Oem_B image: %%a
            %fastboot% -s %serial_number% flash oem_b %%a
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Fatal Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
    )
    if exist oem_other.img (
        echo.
        echo ------ Flashing full Oem_B image ------
        %fastboot% -s %serial_number% flash oem_b oem_other.img
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo Error: fastboot flash oem_b failed^^!
            echo ------------------------------
        )
    )
    :skipFlashOemBImage
    :skipFlashOem

exit /b 0
