@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashAPartQCOM
set /A failure_count=0

    if "%device_has_vbmeta%" EQU "1" (
        if exist vbmeta.img (
            echo.
            echo ------ Flashing VBMeta image ------
            !fastboot! -s !serial_number! flash vbmeta!slotsuffix! vbmeta.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vbmeta failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: VBMeta image does not exist. Skip flashing...
            )
        )
    )

    if "%device_has_vbmeta_system%" EQU "1" (
        if exist vbmeta_system.img (
            echo.
            echo ------ Flashing VBMeta_System image ------
            !fastboot! -s !serial_number! flash vbmeta_system!slotsuffix! vbmeta_system.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vbmeta_system failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: VBMeta_System image does not exist. Skip flashing...
            )
        )
    )

    if "%device_has_bluetooth%" EQU "1" (
        if exist BTFM.bin (
            echo.
            echo ------ Flashing Bluetooth image ------
            !fastboot! -s !serial_number! flash bluetooth!slotsuffix! BTFM.bin
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash bluetooth failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: Bluetooth image does not exist, but your device contain this partition, skip flashing...
            )
        )
    )

    if "%device_has_dsp%" NEQ "1" (
        goto :skipFlashDSP
    )

    REM This is a discriminant for dsp image.
    set /A A=0
    if exist adspso.bin set /A A+=1
    if exist dspso.bin set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: adspso.bin and dspso.bin exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if "%skip_error_prompt%" NEQ "1" (
        if !A! EQU 0 (
            echo.
            echo Warning: DSP image does not exist, but your device contain this partition, skip flashing...
        )
    )
    REM if %A% EQU 1
    if exist adspso.bin (
        echo.
        echo ------ Flashing DSP image ------
        %fastboot% -s %serial_number% flash dsp%slotsuffix% adspso.bin
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo Error: fastboot flash dsp failed^^!
            echo ------------------------------
        )
    ) else (
        if exist dspso.bin (
            echo.
            echo ------ Flashing DSP image ------
            !fastboot! -s !serial_number! flash dsp!slotsuffix! dspso.bin
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash dsp failed^^!
                echo ------------------------------
            )
        )
    )
    :skipFlashDSP

    REM This is a discriminant for logo image.
    set /A A=0
    if exist logo.bin set /A A+=1
    if exist logo.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: logo.bin and logo.img exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if "%skip_error_prompt%" NEQ "1" (
        if !A! EQU 0 (
            echo.
            echo Note: Logo image does not exist. Skipping flash...
        )
    )
    REM if %A% EQU 1
    if exist logo.bin (
        echo.
        echo ------ Flashing Logo image ------
        %fastboot% -s %serial_number% flash logo%slotsuffix% logo.bin
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo Error: fastboot flash logo failed^^!
            echo ------------------------------
        )
    ) else (
        if exist logo.img (
            echo.
            echo ------ Flashing Logo image ------
            !fastboot! -s !serial_number! flash logo!slotsuffix! logo.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash logo failed^^!
                echo ------------------------------
            )
        )
    )

    if exist boot.img (
        echo.
        echo ------ Flashing Boot image ------
        %fastboot% -s %serial_number% flash boot%slotsuffix% boot.img
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo Error: fastboot flash boot failed^^!
            echo ------------------------------
        )
    ) else (
        if "!skip_error_prompt!" NEQ "1" (
            echo.
            echo Warning: Boot image does not exist, this is obviously wrong, please check^^!
        )
    )

    if "%device_has_init_boot%" EQU "1" (
        if exist init_boot.img (
            echo.
            echo ------ Flashing Init_Boot image ------
            !fastboot! -s !serial_number! flash init_boot!slotsuffix! init_boot.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash init_boot failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: Init_Boot image does not exist. Skipping flash...
            )
        )
    )

    if "%device_has_vendor_boot%" EQU "1" (
        if exist vendor_boot.img (
            echo.
            echo ------ Flashing Vendor_Boot image ------
            !fastboot! -s !serial_number! flash vendor_boot!slotsuffix! vendor_boot.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vendor_boot failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: Vendor_Boot image does not exist. Skipping flash...
            )
        )
    )

    if "%device_has_dtb%" EQU "1" (
        if exist dtb.img (
            echo.
            echo ------ Flashing DTB image ------
            !fastboot! -s !serial_number! flash dtb!slotsuffix! dtb.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash dtb failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: DTB image does not exist, but your device contain this partition, skip flashing...
            )
        )
    )

    if "%device_has_dtbo%" EQU "1" (
        if exist dtbo.img (
            echo.
            echo ------ Flashing DTBO image ------
            !fastboot! -s !serial_number! flash dtbo!slotsuffix! dtbo.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash dtbo failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: DTBO image does not exist, but your device contain this partition, skip flashing...
            )
        )
    )

    if "%device_has_recovery%" EQU "1" (
        if exist recovery.img (
            echo.
            echo ------ Flashing Recovery image ------
            !fastboot! -s !serial_number! flash recovery!slotsuffix! recovery.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash recovery failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: Recovery image does not exist, but your device contain this partition, skip flashing.
            )
        )
    )

    if "%device_has_pvmfw%" EQU "1" (
        if exist pvmfw.img (
            echo.
            echo ------ Flashing pVMFW image ------
            !fastboot! -s !serial_number! flash pvmfw!slotsuffix! pvmfw.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash pvmfw failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: Pvmfw image does not exist, but your device contain this partition, skip flashing.
            )
        )
    )

exit /b 0
