@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:getDeviceInfo
color f9
@title %title% %version% - Get device information [%serial_number%]
    REM vers
    set deviceInfoFile=%~dp0deviceInfo_%serial_number%.txt

    REM remove temp device info file
    del /f /s /q "%deviceInfoFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    %fastboot% -s %serial_number% getvar all 2>"%deviceInfoFile%"

    echo.
    echo Fetching...
    REM get variables
    set device_sku=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "sku:" ^| %awk% "{print $3}"') do (
        set device_sku=%%C
    )
    set device_product=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "product:" ^| %awk% "{print $3}"') do (
        set device_product=%%C
    )
    set device_serialno=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "serialno:" ^| %awk% "{print $3}"') do (
        set device_serialno=%%C
    )
    set device_cid=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% -v "iccid:" ^| %grep% "cid:" ^| %awk% "{print $3}"') do (
        set device_cid=%%C
    )
    set device_date=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "date:" ^| %awk% "{print $3}"') do (
        set device_date=%%C
    )
    set device_secure=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "secure:" ^| %awk% "{print $3}"') do (
        set device_secure=%%C
    )
    set device_imei=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "imei:" ^| %awk% "{print $3}"') do (
        set device_imei=%%C
    )
    set device_cpu=
    for /F "tokens=1 delims=:" %%C in ('type "%deviceInfoFile%" ^| %grep% "cpu:" ^| %awk% "{print $3,$4}"') do (
        set device_cpu=%%C
    )
    set device_ram=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "ram:" ^| %awk% "{print $3}"') do (
        set device_ram=%%C
    )
    set storage_type=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "storage-type:" ^| %awk% "{print $3}"') do (
        set storage_type=%%C
    )
    set device_emmc=
    for /F "tokens=1 delims=:" %%C in ('type "%deviceInfoFile%" ^| %grep% "emmc:" ^| %awk% -F": " "{print $2,$3}"') do (
        set device_emmc=%%C
    )
    set device_ufs=
    for /F "tokens=1 delims=:" %%C in ('type "%deviceInfoFile%" ^| %grep% "ufs:" ^| %awk% -F": " "{print $2,$3}"') do (
        set device_ufs=%%C
    )
    set device_ram=
    for /F "tokens=1 delims=:" %%C in ('type "%deviceInfoFile%" ^| %grep% "ram:" ^| %awk% -F": " "{print $2,$3}"') do (
        set device_ram=%%C
    )
    set device_radio=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "radio:" ^| %awk% "{print $3}"') do (
        set device_radio=%%C
    )
    set device_channelid=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "channelid:" ^| %awk% "{print $3}"') do (
        set device_channelid=%%C
    )
    set device_uid=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "uid:" ^| %awk% "{print $3}"') do (
        set device_uid=%%C
    )
    set device_unlocked=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "unlocked:" ^| %awk% "{print $3}"') do (
        set device_unlocked=%%C
    )
    set device_version-bootloader=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "version-bootloader:" ^| %awk% "{print $3}"') do (
        set device_version-bootloader=%%C
    )
    set device_securestate=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "securestate:" ^| %awk% "{print $3}"') do (
        set device_securestate=%%C
    )
    set device_iswarrantyvoid=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "iswarrantyvoid:" ^| %awk% "{print $3}"') do (
        set device_iswarrantyvoid=%%C
    )
    set device_mot_sst=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "mot_sst:" ^| %awk% "{print $3}"') do (
        set device_mot_sst=%%C
    )
    set device_ro_carrier=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "ro.carrier:" ^| %awk% "{print $3}"') do (
        set device_ro_carrier=%%C
    )
    set device_slot_count=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "slot-count:" ^| %awk% "{print $3}"') do (
        set device_slot_count=%%C
    )
    set device_latest_fingerprint=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "ro.build.fingerprint" ^| %awk% -F": " "{print $2}"') do (
        set device_latest_fingerprint=!device_latest_fingerprint!%%C
    )
    set device_latest_baseband=
    for /F "tokens=1 delims=:"  %%C in ('type "%deviceInfoFile%" ^| %grep% "version-baseband" ^| %awk% -F": " "{print $2}"') do (
        set device_latest_baseband=!device_latest_baseband!%%C
    )
    set device_hwrev=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "hwrev:" ^| %awk% "{print $3}"') do (
        set device_hwrev=%%C
    )
    set device_pcb_pn=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "pcb-part-no:" ^| %awk% "{print $3}"') do (
        set device_pcb_pn=%%C
    )
    set device_primary_display=
    for /F %%C in ('type "%deviceInfoFile%" ^| %grep% "primary-display:" ^| %awk% "{print $3}"') do (
        set device_primary_display=%%C
    )
    set device_dualsim=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem hw dualsim 2^>^&1 ^| %%grep%% "dualsim" ^| %%awk%% -F": " "{print $2}"`) do (
        set device_dualsim=%%i
    )

    echo.
    echo ================================================================================
    echo Some information about your device:
    echo ================================================================================
    echo Base Info:
    echo BootLoader version: %device_version-bootloader%
    if "%device_sku%" NEQ "" (
        echo SKU model: %device_sku%
    ) else (
        echo SKU model: Unknown
    )
    if "%device_product%" NEQ "" (
        echo Product Code: %device_product%
    ) else (
        echo Product Code: Unknown
    )
    if "%device_hwrev%" NEQ "" (
        echo Hardware Rev.: %device_hwrev%
    ) else (
        echo Hardware Rev.: Unknown
    )
    if "%device_serialno%" NEQ "" (
        echo Serialno: %device_serialno%
    ) else (
        echo Serialno: Unknown
    )
    if "%device_cid%" NEQ "" (
        echo CID: %device_cid%
    ) else (
        echo CID: Unknown
    )
    if "%device_ro_carrier%" NEQ "" (
        echo Carrier: %device_ro_carrier%
    ) else (
        echo Carrier: Unknown
    )
    if "%device_radio%" NEQ "" (
        echo Radio Code: %device_radio%
    ) else (
        echo Radio Code: Unknown
    )
    if "%device_channelid%" NEQ "" (
        echo Channel ID: %device_channelid%
    ) else (
        echo Channel ID: Unknown
    )
    if "%device_date%" NEQ "" (
        echo Date of manufacture: %device_date%
    ) else (
        echo Date of manufacture: Unknown
    )
    if "%device_imei%" NEQ "" (
        echo IMEI: %device_imei%
    ) else (
        echo IMEI: Unknown
    )
    if "%device_uid%" NEQ "" (
        echo UID: %device_uid%
    ) else (
        echo UID: Unknown
    )
    if "%device_cpu%" NEQ "" (
        echo CPU model: %device_cpu%
    ) else (
        echo CPU model: Unknown
    )

    if "%device_ram%" NEQ "" (
        echo RAM model: %device_ram%
    ) else (
        echo RAM model: Unknown
    )
    if "%device_ufs%" NEQ "" (
        if "!storage_type!" NEQ "eMMC" (
            echo Storage type: UFS
            echo UFS model: !device_ufs!
        )
    )
    if "%device_emmc%" NEQ "" (
        if "!storage_type!" NEQ "UFS" (
            echo Storage type: eMMC
            echo eMMC model: !device_emmc!
        )
    )
    if "%device_primary_display%" NEQ "" (
        echo Primary screen model: %device_primary_display%
    )
    if "%device_secure%" NEQ "" (
        if "!device_secure!" EQU "no" (
            echo Fully unlocked ^( E.g. Engineering Phone ^): Yes
        ) else (
            echo Fully unlocked ^( E.g. Engineering Phone ^): No
        )
    ) else (
        echo Fully unlocked ^( E.g. Engineering Phone ^): Unknown
    )
    if "%device_securestate%" NEQ "" (
        echo BL Secure State: %device_securestate%
    ) else (
        if "!device_mot_sst!" NEQ "" (
            if "!device_mot_sst!" EQU "0" (
                echo BL Secure State: locked
            )
            if "!device_mot_sst!" EQU "1" (
                echo BL Secure State: factory_unlocked
            )
            if "!device_mot_sst!" EQU "2" (
                echo BL Secure State: locked
            )
            if "!device_mot_sst!" EQU "3" (
                echo BL Secure State: unlocked
            )
        ) else (
            if "!device_secure!" NEQ "" (
                echo BL Secure State: Unknown
            ) else (
                if "!device_secure!" EQU "yes" (
                    echo BL Secure State: locked
                ) else (
                    if "!device_secure!" EQU "no" (
                        echo BL Secure State: unlocked
                    ) else (
                        echo BL Secure State: Unknown
                    )
                )
                )
            )
        )
    )
    if "%device_unlocked%" NEQ "" (
        if "!device_unlocked!" EQU "Not" (
            echo BL Lock State: unlocked
        )
        if "!device_unlocked!" EQU "yes" (
            echo BL Lock State: unlocked
        )
        if "!device_unlocked!" EQU "no" (
            echo BL Lock State: locked
        )
    ) else (
        if "!device_securestate!" NEQ "" (
            if "!device_securestate!" EQU "flashing_unlocked" (
                echo BL Lock State: unlocked
            )
            if "!device_securestate!" EQU "oem_locked" (
                echo BL Lock State: locked
            )
        ) else (
            echo BL Lock State: Unknown
        )
    )
    if "%device_iswarrantyvoid%" NEQ "" (
        if "!device_iswarrantyvoid!" EQU "yes" (
            echo Warranty fuse: Blown
        ) else (
            echo Warranty fuse: Normal
        )
    ) else (
        echo Warranty fuse: Unknown
    )
    if "%device_slot_count%" NEQ "" (
        if "!device_slot_count!" EQU "2" (
            echo Slot A/B partition support: Yes
        ) else (
            echo Slot A/B partition support: No
        )

    ) else (
        echo Slot A/B partition support: Unknown
    )
    if "%device_latest_fingerprint%" NEQ "" (
        echo Latest booted firmware fingerprint: %device_latest_fingerprint%
    ) else (
        echo Latest booted firmware fingerprint: Unknown
    )
    if "%device_latest_baseband%" NEQ "" (
        echo Latest booted baseband version: %device_latest_baseband%
    ) else (
        echo Latest booted baseband version: Unknown
    )
    if "%device_pcb_pn%" NEQ "" (
        echo Motherboard PCB Part Number: %device_pcb_pn%
    )
    if "%device_dualsim%" NEQ "" (
        if "!device_dualsim!" EQU "true" (
            echo Dual SIM card: Yes
        )
        if "!device_dualsim!" EQU "false" (
            echo Dual SIM card: No
        )
    ) else (
        echo Dual SIM card: Unknown
    )

    echo --------------------------------------------------------------------------------
    echo Security Version Fuse ^( SV FUSE ^) Info:

    %fastboot% -s %serial_number% oem read_sv

    echo ================================================================================
    REM remove temp file
    del /f /s /q "%deviceInfoFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
:tips
    echo.
    echo Press any key to exit.
    pause > nul
    goto :exit
::
::
:exit
exit
