@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menuGloalConfig
@title %title% %version% - Global Configuration
color f9
    echo --------------------------------------------------------------------------------
    echo. [1] Change the default Fastboot version
    echo. [2] Don't reboot the Bootloader during flashing full firmware [%flashall_skip_reboot_bl%]
    echo. [3] Reboot after flashing the full firmware [%finished_reboot%]
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
    set selection=
    set /p selection= Please enter the option number: ^>^>
        if "%selection%"=="1" cls && call "%~dp0menuSetFastboot.cmd" && exit /b 0
        if "%selection%"=="2" cls && call :skipRebootBLTips
        if "%selection%"=="3" cls && call :finishedRebootTips
        if "%selection%"=="0" cls && exit /b 0
    cls
goto :menuGloalConfig
::
::
:skipRebootBLTips
@title %title% %version% - Don't reboot the Bootloader during flashing full firmware
    echo --------------------------------------------------------------------------------
    echo. [*] During flashing of the full firmware, reboot the Bootloader after flashing the BL part.
    echo This will make the device apply the new Bootloader,
    echo and automatically switch to slot A to complete the next flashing steps.
    echo If you don't need to reboot the bootloader during flashing full firmware, you can turn it off.
    echo.
    echo --------------------------------------------------------------------------------
    echo.

    call :skipRebootBLOpt

    color f2
    echo.
    echo Operation is complete.
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
::
:skipRebootBLOpt
    set opts=
    set /p opts= Do you need to restart BL during flashing full firmware ^(Y/N^)? ^>^>
        if /i "%opts%"=="y" cls && call :setSkipRebootBL 0 && exit /b 0
        if /i "%opts%"=="n" cls && call :setSkipRebootBL 1 && exit /b 0
goto :skipRebootBLOpt
::
::
:setSkipRebootBL
REM vars
set flashall_skip_reboot_bl=

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    )

    echo.
    echo ==^> Writing configuration file...
    REM oem operation
    type "%~dp0variable.bat" | %sed% "s@ flashall_skip_reboot_bl=.*@ flashall_skip_reboot_bl=%1@g" 2>&1 > "%~dp0a.txt"

    %mv% "%~dp0a.txt" "%~dp0variable.bat"
    call "%~dp0variable.bat"
exit /b 0
::
::
::
::
:finishedRebootTips
@title %title% %version% - Reboot after flashing the full firmware
    echo --------------------------------------------------------------------------------
    echo. [*] When the full firmware flashing is complete, reboot into the system
    echo.
    echo --------------------------------------------------------------------------------
    echo.

    call :finishedRebootOpt

    color f2
    echo.
    echo Operation is complete.
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
::
:finishedRebootOpt
    set opts=
    set /p opts= Do you need to reboot after the full firmware flashing is complete ^(Y/N^)? ^>^>
        if /i "%opts%"=="y" cls && call :setFinishedReboot 1 && exit /b 0
        if /i "%opts%"=="n" cls && call :setFinishedReboot 0 && exit /b 0
goto :finishedRebootOpt
::
::
:setFinishedReboot
REM vars
set finished_reboot=

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    )

    echo.
    echo ==^> Writing configuration file...
    REM oem operation
    type "%~dp0variable.bat" | %sed% "s@ finished_reboot=.*@ finished_reboot=%1@g" 2>&1 > "%~dp0a.txt"

    %mv% "%~dp0a.txt" "%~dp0variable.bat"
    call "%~dp0variable.bat"
exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
