@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menuToolbox
@title %title% %version% - Toolbox
color f9
    echo --------------------------------------------------------------------------------
    echo. [1] Flashfile XML to BAT
    echo. [2] Run custom action steps
    echo. [3] Run clear factory parameters
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
    set selection=
    set /p selection= Please enter the option number:^>^>
        if "%selection%"=="1" cls && call :runXML2BAT
        if "%selection%"=="2" cls && call :runCustomStep
        if "%selection%"=="3" cls && call :cleanFactoryParam
        if "%selection%"=="0" cls && exit /b 0
    cls
goto :menuToolbox
::
::
:runXML2BAT
@title %title% %version% - Flashfile XML to BAT
    echo --------------------------------------------------------------------------------
    echo. [*] This tool will convert flashfile.xml to .bat batch file.
    echo. [*] Please note that the generated batch will only work with the current firmware,
    echo do not try to use it with other firmware.
    echo. [*] The generated file name is xml2batflash.bat, if you want to use it,
    echo please double-click to execute it.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul

    echo.
    set xmlfilename=
    set /p xmlfilename= Please enter xml file name and press Enter ^(default: flashfile.xml^)^>^>%=%
        if "%xmlfilename%"=="" (
            set xmlfilename=flashfile.xml
        )

    if not exist "%xmlfilename%" (
        color fc
        echo.
        echo "%xmlfilename%" does not exist^^! Please check^^!
        goto :tips
    )
    call :resetOpt

    color f2
    echo.
    echo The operation is complete.
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
::
:resetOpt
    set factoryreset=
    set /p factoryreset= Do you need to do a factory reset?^(Y/N^)? ^>^>
        if /i "%factoryreset%"=="y" cls && call "%~dp0runXML2BAT.cmd" "%xmlfilename%" 1 && exit /b 0
        if /i "%factoryreset%"=="n" cls && call "%~dp0runXML2BAT.cmd" "%xmlfilename%" 0 && exit /b 0
goto :resetOpt
::
::
:runCustomStep
@title %title% %version% - Run custom action steps
    echo --------------------------------------------------------------------------------
    echo. [*] The customstep.cmd BAT you set in the custom folder will be executed.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul

    if exist "%TFS_ROOT%\tools\custom\customstep.cmd" (
        echo.
        echo Performing custom action steps...
        call "%TFS_ROOT%\tools\custom\customstep.cmd"
    ) else (
        color fc
        echo.
        echo Could not find customstep.cmd, please check.
        goto :tips
    )

    color f2
    echo.
    echo The operation is complete.
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
::
:cleanFactoryParam
@title %title% %version% - Clear Factory Parameters
    echo --------------------------------------------------------------------------------
    echo. [*] The factory parameter will be cleaned up.
    echo E.g. ramdump, cmdl, off-charge-mode etc.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runCleanFactoryParam.cmd"
            ) else (
                start cmd /k call "%~dp0runCleanFactoryParam.cmd"
            )

        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Press any key to return to the Toolbox menu.
    pause > nul
exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
