@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runFlashCustomAction
color f9
@title %title% %version% - Flashing custom firmware [%serial_number%]
set /A failure_count=0
set /A total_failure_count=0
set skip_error_prompt=1

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        echo.
        echo ==^> Execute custom CMD script...
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if !errorlevel! NEQ 0 (
            echo.
            echo Device [!serial_number!] failed to execute custom script^^!
            goto :flashFailedLabel
        )

        if "!fully_customizable!" == "1" (
          goto :skipDoFlashCustom
        )

    )

    if "%device_is_qcom%" EQU "1" (
        call "%~dp0doFlashAPartQCOM.cmd"
        if "!device_has_super!" EQU "1" (
            call "%~dp0doFlashAPartSuper.cmd"
        )
        call "%~dp0doFlashBPartQCOM.cmd"
        goto :endFlashAPBP
    )

    if "%device_is_mtk%" EQU "1" (
        call "%~dp0doFlashAPartMTK.cmd"
        if "!device_has_super!" EQU "1" (
            call "%~dp0doFlashAPartSuper.cmd"
        )
        call "%~dp0doFlashBPartMTK.cmd"
        goto :endFlashAPBP
    )

    if "%device_is_slsi%" EQU "1" (
        call "%~dp0doFlashAPartSLSI.cmd"
        if "!device_has_super!" EQU "1" (
            call "%~dp0doFlashAPartSuper.cmd"
        )
        call "%~dp0doFlashBPartSLSI.cmd"
        goto :endFlashAPBP
    )

    :endFlashAPBP

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] regular partition iamges flash failed.
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    echo.
    echo ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

    for /F "usebackq tokens=*" %%C in (`%%fastboot%% -s "%%serial_number%%" getvar product 2^>^&1 ^>nul ^| %%grep%% "product:" ^| %%awk%% -F: "{print $2}" ^| %%sed%% "s@ @@g"`) do (
        set deviceName=%%C
    )

    if "%deviceName%" == "nash" ( set oem_as_vendor=1 )

    if "%oem_as_vendor%" == "1" (
        if exist vendor.img (
            echo.
            echo Note: Old model detected, device name: [!deviceName!]
            echo OEM partition has been used as Vendor partition, renaming image names...
            !mv! -f vendor.img oem.img
        )
    )

    if "%device_has_super%" EQU "1" (
        if "!skip_fastbootd_action!" NEQ "1" (
            call :doFastbootdActions
        )
    ) else (
        call "%~dp0doFlashSeparatedSuper.cmd"
    )

    :skipDoFlashCustom

    if "%finished_factory_reset%" == "1" (
        echo.
        echo ======== Factory reset ========

        call "%~dp0doFactoryReset.cmd"
        if !errorlevel! NEQ 0 (
            echo Device [!serial_number!] factory reset failed.
            goto :flashFailedLabel
        )
        set /A total_failure_count+=!failure_count!
    )

    if exist "%TFS_ROOT%tools\custom\customend.cmd" (
        echo.
        echo ==^> Execute custom CMD script ^( End ^)...
        call "%TFS_ROOT%tools\custom\customend.cmd"
        if !errorlevel! NEQ 0 (
            echo.
            echo Device [!serial_number!] failed to execute custom script ^( End ^)^^!
            goto :flashFailedLabel
        )
    )

    if "%finished_reboot%" == "1" (
        echo.
        echo ==^> Rebooting to system...
        %fastboot% -s %serial_number% reboot
    )

    if %total_failure_count% EQU 0 ( color f2 )
    echo.
    echo Device [%serial_number%] all operations are complete. Total of %total_failure_count% errors.

    :flashFailedLabel
    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:doFastbootdActions
    echo.
    echo ==^> The device contains dynamic partition, will enter fastbootd mode...

    echo.
    echo ------ Rebooting fastbootd mode ------
    %fastboot% -s %serial_number% reboot fastboot
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo Fatal Error: Rebooting Fastbootd mode failed^^!
        echo.
        goto :flashFailedLabel
    )

    ping -n 3 127.1 > nul 2>nul

    echo.
    echo ------ Reconnecting [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo Fatal Error: Reconnecting [%serial_number%] failed^^!
        echo.
        goto :flashFailedLabel
    )

    call "%~dp0getFastbootdPT.cmd"

    call "%~dp0doFlashSeparatedSuper.cmd"

    set /A total_failure_count+=%failure_count%

    echo.
    REM reboot-bootloader.
    echo ------ Rebooting to fastboot ------
    %fastboot% -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo Fatal Error: Reboot Fastboot failed^^!
        echo.
        goto :flashFailedLabel
    )

    ping -n 6 127.1 > nul 2>nul

    echo.
    echo ------ Reconnecting [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo Fatal Error: Reconnecting [%serial_number%] failed^^!
        echo.
        goto :flashFailedLabel
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
