@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runFlashRec
color f9
@title %title% %version% - Flash Recovery [%serial_number%]
REM vars
set flash_rec_option=

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    ) else (
        set flash_rec_option=%1
    )

    call "%~dp0getPartitionTable.cmd"

    if "%flash_rec_option%" == "1" call :directFlashRecovery
    if "%flash_rec_option%" == "2" call :bootRecoveryOneTime

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
    ) else (
        color f2
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )
exit /b 0
::
::
:directFlashRecovery
@title %title% %version% - Flash Recovery [%serial_number%]
    echo.
    echo ------ Flashing Recovery image ------
    if exist recovery.img (
        echo.
        echo ==^> Setting FB mode...
        %fastboot% -s %serial_number% oem fb_mode_set
        %fastboot% -s %serial_number% flash recovery%slotsuffix% recovery.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Failed: fastboot flash recovery failed^^!
            echo ------------------------------
            exit /b 1
        )
        echo.
        echo ==^> Clean FB mode...
        %fastboot% -s %serial_number% oem fb_mode_clear

    ) else (
        color fc
        echo.
        echo Fatal Error: Recovery image does not exist. This is obviously wrong, please check^^!
        exit /b 1
    )

exit /b 0
::
::
:bootRecoveryOneTime
@title %title% %version% - Direct booting Recovery [%serial_number%]
    echo.
    echo ------ Direct booting Recovery image ------
    if exist recovery.img (
        %fastboot% -s %serial_number% boot recovery.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Error: fastboot booting recovery failed^^!
            echo ------------------------------
            exit /b 1
        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Recovery image does not exist. This is obviously wrong, please check^^!
        exit /b 1
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
