@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runUnlockBL
color f9
@title %title% %version% - Unlock Bootloader [%serial_number%]

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    ) else (
        set unlock_option=%1
    )

    REM call "%~dp0getPartitionTable.cmd"

    if "%unlock_option%" == "1" call :doUnlockFlashingBL
    if "%unlock_option%" == "2" call doUnlockOemBL
    if "%unlock_option%" == "3" call :doUnlockOemMotoBL
    if "%unlock_option%" == "4" call :runGetUnlockData

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
    ) else (
        color f2
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:doUnlockFlashingBL
@title %title% %version% - Unlock Bootloader [%serial_number%]
    echo.
    echo Executing: fastboot -s %serial_number% flashing unlock
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% flashing unlock 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count 
    if %okay_count% == 0 (
        color fc
        echo ---------------------------
        echo Error: Operation failed^^!
        echo ---------------------------
        exit /b 1
    )

    color f2
    echo.
    echo The operation is complete.

exit /b 0
::
::
:doUnlockOemMotoBL
@title %title% %version% - Unlock Motorola Bootloader [%serial_number%]
    echo.
    echo. [-] NOTE: Please enter the unlock code for [%serial_number%], then press Enter.
    echo. [-] For example: DVNJ6NFFT2MLEZABQ4FQ
    echo.
    set unlockcode=
    set /p unlockcode= Please enter the unlock code: ^>^>
        if "%unlockcode%"=="" (
            echo The input is incorrect, please re-enter.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :doUnlockOemMotoBL
        )

    echo.
    echo Executing: fastboot -s %serial_number% oem unlock %unlockcode%
    %fastboot% -s %serial_number% oem unlock %unlockcode%
    REM Confirm unlock again
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem unlock %%unlockcode%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X 2^>^&1 ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count 
    if %okay_count% == 0 (
        color fc
        echo ---------------------------
        echo Error: Operation failed^^!
        echo ---------------------------
        exit /b 1
    )

    color f2
    echo.
    echo The operation was successful.

exit /b 0
::
::
:runGetUnlockData
@title %title% %version% - Get Device ID [%serial_number%]

    echo.
    echo Fetch Bootloader unlock data for [%serial_number%]:
    echo.
    call "%~dp0doGetUnlockData.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo Fetching Bootloader unlock data failed^^!
        goto :tips
    )

    echo %ULKData%

    if %device_count% == 1 (
        REM do not try to format this line
        echo %ULKData%| clip
        echo.
        echo Your Device ID has been copied to the clipboard.
    )

    if %device_count% NEQ 1 (
        echo.
        echo Writing file: UnlockData_%serial_number%.txt
        echo %ULKData% > UnlockData_%serial_number%.txt
        goto :tips
    )

exit /b 0
::
::
:doUnlockOemBL
@title %title% %version% - Unlock Bootloader [%serial_number%]
    echo.
    echo Executing: fastboot -s %serial_number% oem unlock
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem unlock 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=1" %%C in (`echo %%X ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count 
    if %okay_count% == 0 (
        color fc
        echo ---------------------------
        echo Error: Operation failed^^!
        echo ---------------------------
        exit /b 1
    )

    color f2
    echo.
    echo The operation was successful.

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
